
CoCoA-5 - Bug #1531

CRASH: arithmetic with HilbertSeries (tagged object)

05 Nov 2020 14:41 - John Abbott

Status: Closed Start date: 05 Nov 2020

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: bug Estimated time: 0.99 hour

Target version: CoCoA-5.4.0 Spent time: 1.00 hour

Description

The following input causes an assertion failure, followed by abort:

// use R ::= QQ[x,y,z];

1 + HilbertSeries(R);

 

The response is

--> WARNING: I'm implicitly untagging the right operand; use untagged() to avoid this warning

--> 1 + HilbertSeries(R);

-->   ^

CoCoAInterpreter: Interpreter.C:1448: bool CoCoA::InterpreterNS::TYPE::isProperSubtypeOf(int) cons

t: Assertion `false' failed.

Process cocoa5 aborted (core dumped)

History

#1 - 05 Nov 2020 15:07 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

The troublesome call is on line 1536 of Interpreter.C.

The problem is that rightType has dispatchIndex equal to -1 (meaning tagged, I suppose).

I guess what happened is the following:

the first attempt with leftType->isProperSubtypeOf fails, so it falls through to line 1536...

Perhaps there should be a check right before 1536, if rightType->dispatchIndex is negative then an error should be thrown.

Or perhaps just change Interpreter.C at line 1448 to throw a normal error rather than @assert(false).  What should the err mesg say?

Or maybe 1536 should call rightOp->getType()->isProperSybtypeOf(...).    This seems plausible

#2 - 05 Nov 2020 15:12 - John Abbott

- Priority changed from Normal to High

- % Done changed from 10 to 20
I have just tried using my last idea rightOp->getType()->isProperSybstypeOf(..).

It compiled, and now produces a vaguely sane error mesg:

/**/ --> WARNING: I'm implicitly untagging the right operand; use untagged() to avoid this warning

--> WHERE: at line 2 (column 2) of BUG-HilbertSeries.cocoa5

--> 1+HilbertSeries(R);

-->  ^

--> ERROR: I don't know how to evaluate operator + between INT and RECORD

--> WHERE: at line 2 (column 2) of BUG-HilbertSeries.cocoa5

--> 1+HilbertSeries(R);

-->  ^

--> ERROR: Read and execution of the source file "/home/jabbott/ShortTerm/BUG-HilbertSeries.cocoa5" failed

--> source "/home/jabbott/ShortTerm/BUG-HilbertSeries.cocoa5";

--> ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

 

Anyway, it didn't crash/abort.

This might be a reasonable solution.  All CoCoA-5 tests pass too  :-)

#3 - 05 Nov 2020 19:00 - John Abbott

- Assignee set to John Abbott

- % Done changed from 20 to 40

At least + is commutative: HilbertSeries(...)+1 also causes a crash!

I have modified Interpreter.C, and checked in... sigh!

#4 - 10 Nov 2020 14:07 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 40 to 80

#5 - 15 Jan 2021 06:48 - Anna Maria Bigatti

- Subject changed from CRASH: arithmetic with HilbertSeries to CRASH: arithmetic with HilbertSeries (tagged object)

It (correctly) gives error both on right and left, no crash.

#6 - 24 Sep 2021 22:16 - John Abbott

- Status changed from Feedback to Closed
- % Done changed from 80 to 100

- Estimated time set to 0.99 h

There is already a test in exbugs.cocoa5

Closing after 11 months in feedback.

Powered by TCPDF (www.tcpdf.org)

29 Apr 2024 3/3

http://www.tcpdf.org

